<?php

//  Copyright (C) 2002-2006 Balint Kis (balint-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

function display_clients($database, $my_user_id) {
  global $user_type;
  global $color;
  global $style;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr bgcolor=\"$color[table_top]\">\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"6\"><font class=\"tabletop\">My Clients</font></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=$color[table_header]  width=\"50%\">Client Name</td>\n";
  print "<td align=\"left\" bgcolor=$color[table_header]  width=\"15%\">Status</td>\n";
  print "<td align=\"left\" bgcolor=$color[table_header]  width=\"10%\">Trusted</td>\n";
  print "<td align=\"left\" bgcolor=$color[table_header]  width=\"15%\">Registration Date</td>\n";
  print "<td align=\"left\" bgcolor=$color[table_header]  width=\"10%\" colspan=\"2\">&nbsp;</td>\n";
  print "</tr>\n";

  $all_clients = pg_query($database, "select identifier, client, last_name, first_name, date_of_creation, value, type, trusted
                                        from view_client
                                       where users='$my_user_id'");
  $num_of_clients = pg_num_rows($all_clients);

  for ($i = 0; $i < $num_of_clients; $i++) {
    $client = pg_fetch_row($all_clients, $i);
    if ($client[2] != '' && $client[3] != '') {
      $client[2] = sprintf("%s,", $client[2]);
    }

    print "<tr>\n";
    if ($client[6] > $user_type['client'])
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"user.php?user=$client[1]\">$client[2] $client[3]</a></td>\n";
    else
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$client[2] $client[3]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$client[5]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >"; display_yes_no_text($client[7]); print "</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($client[4], 'date', 1). "</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" width=\"5%\"><a href=\"client.edit.php?client=$client[0]\">Edit</a></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" width=\"5%\"><a href=\"client.del.php?client=$client[0]\">Delete</a></td>\n";
    print "</tr>\n";
  }

  print "</table>\n";
}

function display_protected_photographers($database, $my_user_id) {
  global $color;
  global $style;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr bgcolor=\"$color[table_top]\">\n";
  print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"4\"><font class=\"tabletop\">I am the client of the following users</font></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=$color[table_header] width=\"50%\">User</td>\n";
  print "<td align=\"left\" bgcolor=$color[table_header] width=\"20%\">Status</td>\n";
  print "<td align=\"left\" bgcolor=$color[table_header] width=\"20%\">Registration Date</td>\n";
  print "<td align=\"left\" bgcolor=$color[table_header] width=\"10%\">&nbsp;</td>\n";
  print "</tr>\n";

  $all_subscribed_users = pg_query($database, " select identifier, users, last_name, first_name, date_of_creation, value from view_users_subscribed_to where client='$my_user_id' and status!='4'");
  $num_of_subscribed_users = pg_num_rows($all_subscribed_users);

  for ($i = 0; $i < $num_of_subscribed_users; $i++) {
    $subscribed_user = pg_fetch_row($all_subscribed_users, $i);
    if ($subscribed_user[2] != '' && $subscribed_user[3] != '') {
      $subscribed_user[2] = sprintf("%s,", $subscribed_user[2]);
    }
    print "<tr>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"><a href=\"user.php?user=$subscribed_user[1]\">$subscribed_user[2] $subscribed_user[3]</a></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">$subscribed_user[5]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\">".generate_date_html($subscribed_user[4], 'date', 1). "</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"><a href=\"subscription.del.php?client=$subscribed_user[0]\">Delete</a></td>\n";
    print "</tr>\n";
  }
  print "</table>\n";
}

?>
