<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  /* =============================================================== */

  // "name" => array("db_file" => db_file_name,
  //                 "dat_file" => dat_file_name,
  //                 "pre" => pre_function,
  //                 "post => post_function);

$versions = array("(none)" =>
		  array("db_file" => "po.db.02.05.sql",
			"dat_file" => "po.data.02.05.sql",
			"pre" => "po205_new_install"),
		  "2.05" =>
		  array("db_file" => "po.db.02.05.to.02.06.sql",
			"dat_file" => "po.data.02.05.to.02.06.sql"),
		  "2.06" =>
		  array("db_file" => "po.db.02.06.to.02.07.sql",
			"dat_file" => "po.data.02.06.to.02.07.sql",
			"post" => "po207_first_volume"),
		  "2.07" =>
		  array("db_file" => "po.db.02.07.to.02.08.sql",
			"dat_file" => "po.data.02.07.to.02.08.sql"),
		  "2.08" =>
		  array("db_file" => "po.db.02.08.to.02.09.sql",
			"dat_file" => "po.data.02.08.to.02.09.sql"),
		  "2.09" =>
		  array("db_file" => "po.db.02.09.to.02.10.sql",
			"dat_file" => "po.data.02.09.to.02.10.sql"),
		  "2.10" =>
		  array("db_file" => "po.db.02.10.to.02.11.sql",
			"dat_file" => "po.data.02.10.to.02.11.sql"),
		  "2.11" =>
		  array("db_file" => "po.db.02.11.to.02.12.sql",
			"dat_file" => "po.data.02.11.to.02.12.sql"),
		  "2.12" =>
		  array("db_file" => "po.db.02.12.to.02.13.sql",
			"dat_file" => "po.data.02.12.to.02.13.sql"),
		  "2.13" =>
		  array("db_file" => "po.db.02.13.to.02.14.sql",
			"dat_file" => "po.data.02.13.to.02.14.sql",
			"post" => "po213_214_migrate_repo"),
		  "2.14" =>
		  array("db_file" => "po.db.02.14.to.02.15.sql",
			"dat_file" => "po.data.02.14.to.02.15.sql"),
		  "2.15" =>
		  array("db_file" => "po.db.02.15.to.02.16.sql",
			"dat_file" => "po.data.02.15.to.02.16.sql",
			"pre" => "po215_216_createlang"), 
		  "2.16" =>
		  array("db_file" => "po.db.02.16.to.02.17.sql",
			"dat_file" => "po.data.02.16.to.02.17.sql"),
		  "2.17" =>
		  array("db_file" => "po.db.02.17.to.02.18.sql",
			"dat_file" => "po.data.02.17.to.02.18.sql"),
		  "2.18" =>
		  array("db_file" => "po.db.02.18.to.02.19.sql",
			"dat_file" => "po.data.02.18.to.02.19.sql"),
		  "2.19" =>
		  array("db_file" => "po.db.02.19.to.02.20.sql",
			"dat_file" => "po.data.02.19.to.02.20.sql"),
		  "2.20" =>
		  array("db_file" => "po.db.02.20.to.02.21.sql",
			"dat_file" => "po.data.02.20.to.02.21.sql"),
		  "2.21" =>
		  array("db_file" => "po.db.02.21.to.02.22.sql",
			"dat_file" => "po.data.02.21.to.02.22.sql"),
		  "2.22" =>
		  array("db_file" => "po.db.02.22.to.02.23.sql",
			"dat_file" => "po.data.02.22.to.02.23.sql"),
		  "2.23" =>
		  array("db_file" => "po.db.02.23.to.02.24.sql",
			"dat_file" => "po.data.02.23.to.02.24.sql"),
		  "2.24" =>
		  array("db_file" => "po.db.02.24.to.02.25.sql",
			"dat_file" => "po.data.02.24.to.02.25.sql"),
		  "2.25" =>
		  array("db_file" => "po.db.02.25.to.02.26.sql",
			"dat_file" => "po.data.02.25.to.02.26.sql"),
		  "2.26" =>
		  array("db_file" => "po.db.02.26.to.02.27.sql",
			"dat_file" => "po.data.02.26.to.02.27.sql"),
		  "2.27" =>
		  array("db_file" => "po.db.02.27.to.02.28.sql",
			"dat_file" => "po.data.02.27.to.02.28.sql"),
		  "2.28" =>
		  array("db_file" => "po.db.02.28.to.02.29.sql",
			"dat_file" => "po.data.02.28.to.02.29.sql"),
		  "2.29" =>
		  array("db_file" => "po.db.02.29.to.02.30.sql",
			"dat_file" => "po.data.02.29.to.02.30.sql"),
		  "2.30" =>
		  array("db_file" => "po.db.02.30.to.02.31.sql",
			"dat_file" => "po.data.02.30.to.02.31.sql"),
		  "2.31" =>
		  array("db_file" => "po.db.02.31.to.02.32.sql",
			"dat_file" => "po.data.02.31.to.02.32.sql"),
		  );

  /* =============================================================== */

function po205_new_install($dbh) {
  global $image_repository_path;
  global $first_volume;
  global $new_install;

  $new_install = TRUE;
  print "<li>Creating initial image repository...";
  if (file_exists("$image_repository_path/$first_volume")) {
    print "<font color=\"red\">FAILED</font> (directory exists!)</li>\n";
    return FALSE;
  }
  $res = mkdir("$image_repository_path/$first_volume", 0755);
  if ($res === TRUE) {
    print "<font color=\"green\">OK</font></li>\n";
  } else {
    print "<font color=\"red\">FAILED</font> <pre>$image_repository_path/$first_volume</pre></li>\n";
  }
  return $res;
}

function po207_first_volume($dbh) {
  global $image_repository_path;
  global $first_volume;

  if (pg_query($dbh, "update system_preferences set current_volume='$first_volume'") !== FALSE)
    return TRUE;
  else
    return FALSE;
}

function po213_214_migrate_repo($dbh) {
  global $image_repository_path;
  global $new_install;

  if ($new_install === TRUE) {
    print "<li>Creating new image repository layout...";
    $res = mkdir("$image_repository_path/$first_volume/00000", 0755);
    if ($res === TRUE)
      $res = mkdir("$image_repository_path/$first_volume/00001", 0755);
    if ($res === TRUE)
      $res = mkdir("$image_repository_path/$first_volume/00002", 0755);
    if ($res === TRUE) {
      print "<font color=\"green\">OK</font></li>\n";
    } else {
      print "<font color=\"red\">FAILED</font></li>\n";
    }
    return $res;
  }
  
  /* This function lifted mostly out of the old migrate.php.  
   I haven't tested it.. */

  print "<li>Migrating image repository to new (v2.14+) layout...";

  $conversion = array(array("desc" => "originals",  "prefix" => "hires", "sql_field" => "large_image_path",  "subvolume" => "00000"),
		      array("desc" => "previews",   "prefix" => "image", "sql_field" => "medium_image_path", "subvolume" => "00001"),
		      array("desc" => "thumbnails", "prefix" => "thumb", "sql_field" => "small_image_path",  "subvolume" => "00002"));
  
  $handle = opendir($image_repository_path);
  if ($handle === FALSE) {
    print "<font color=\"red\">FAILED</font> (couldn't open $image_repository_path)</li>\n";
    return FALSE;
  }
  print "</li>\n";
  print "<ul>\n";

  /* CONVERT EACH VOLUME IN THE IMAGE REPOSITORY */
  while (false !== ($directory = readdir($handle))) {
    if ($directory == "." || $directory == "..")
      continue;

    $volume = $image_repository_path ."/". $directory;
    print "<li>Migrating volume <b>" . $volume . "</b></li>";
    print "<ul>";

    /* FOR EACH FORMAT REPEAT THE FOLLOWING 3 STEPS */
    foreach ($conversion as $conv) {
      print "<li>Processing " . $conv['desc'];
      print "<ul>";
      $subdir = $volume ."/" . $conv['subvolume'];
      /* STEP 1 - CREATE NEW SUB-VOLUME */
      print "<li>Creating subdirectory <b>". $subdir ."</b> ... ";
      $result = mkdir($subdir);
      if ($result)
        print "<font color=\"green\"><b>OK</b></font>";
      else {
        print "<font color=\"red\"><b>FAILED</b></font>";
      }
      print "</li>";

      /* STEP 2 - MOVE THE APROPRIATE IMAGE FILES */
      $sql_field = $conv['sql_field'];
      $images_in_this_volume = pg_query($dbh, "
       select photo,
              $sql_field,
              (substr($sql_field,  char_length('$directory')+2)) as short
         from photo_version
        where '$directory' = substr($sql_field,  0, char_length('$directory') +1 )");

      $num_of_files = pg_num_rows($images_in_this_volume);
      for ($idx = 0; $idx < $num_of_files; $idx++) {
        $image = pg_fetch_row($images_in_this_volume, $idx);
        $image[2] = substr($image[2], 5);
        print "<li>Moving <b>". $image_repository_path . "/". $image[1] ."</b> to <b>". $subdir ."/". $image[2]. "</b> ... ";
        $result = rename($image_repository_path . "/". $image[1], $subdir ."/". $image[2]);
        if ($result) {
          print "<font color=\"green\"><b>OK</b></font>";
	} else {
          print "<font color=\"red\"><b>FAILED</b></font>";
        }
        print "</li>";
      }

      /* STEP 3 - UPDATE THE DATABASE */
      print "<li>Updating database ... ";
      $result = pg_query($dbh, "
       update photo_version
          set $sql_field = ('".$directory."/".$conv['subvolume'] ."/' || (substr($sql_field,  char_length('".$directory."/".$conv['prefix']."') + 1)))
        where '".$directory."/".$conv['prefix']."' = substr($sql_field,  0, char_length('".$directory."/".$conv['prefix']."') +1 )");

      if ($result) {
        print "<font color=\"green\"><b>OK</b></font>";
      } else {
        print "<font color=\"red\"><b>FAILED</b></font>";
      }
      print "</li>";

      print "</ul>";
      print "</li>";
    }
    print "</ul>";
  }
  closedir($handle);

  print "</ul>\n";
  print "<li>....<font color=\"green\">Migration Successful</font></li>\n";

  return TRUE;
}

function po215_216_createlang($dbh) {
  global $db_name;

  $res = pg_query("select * from pg_language where lanname = 'plpgsql'");

  print "<li>Checking for PL/PGSQL support...";

  if (pg_num_rows($res) > 0) {
    print "<font color=\"green\">OK</font></li>\n";
    return TRUE;
  }

  print "<font color=\"red\">FAILED</font></li>\n";
  print "<li>Run this command as root:<br/>\n";
  print "<pre>su - postgres -c \"createlang plpgsql $db_name\"</pre></li>\n";

  return FALSE;
}

  /* =============================================================== */

function po_process_db_file($dbh, $file) {
 $fh = fopen($file, 'r');
  if (!$fh) {
    print (" can't open file $row[db_file] \n");
    return FALSE;
  }
  $quot = 0;

#  $buffer = "-- ";
  $buffer = "";
  while (!feof($fh)) {
    $line = fgets($fh, 1024);
#    print ("READ:<pre>$line</pre><br/>\n");
    $offset = strpos($line, '--');
    if ($offset !== FALSE) {
      $line = substr($line, 0, $offset);
    }
    $line = trim($line);
    $buffer .= " $line";

    $offset = strrpos($line, "'");
    if ($offset === (strlen($line) -1)) {
      $quot = 1;
      continue;
    } else if (substr($line, 0, 1) === "'") {
      $quot = 0;
    }

#    print ("READ2: <pre>$quot offset $offset " . strlen($line) ."</pre><br/><pre>$buffer</pre><br/>");

    $offset = strrpos($buffer, ";");
    if (($quot == 0) && ($offset === (strlen($buffer)-1))) {
      $buffer = substr($buffer, 0, $offset);
#      print ("EXEC: <pre>$buffer</pre><br/>");
      $res = pg_query($dbh, $buffer);
      if ($res === FALSE) {
	return FALSE;
      }
      $buffer = "";
#     $buffer = "-- ";
    }
  }
  fclose($fh);
  if ($quot == 1) {
    return FALSE;
  }

  return TRUE;
}

function po_get_version($dbh) {
  $query = pg_query($dbh, "select major, minor, variation from version");
  if ($query != FALSE) {
    $row = pg_fetch_row($query);
    $version = sprintf("%d.%02d", $row[0],$row[1]);
  } else {
    $version = "(none)";
  }
  return $version;
}

  /* =============================================================== */

function display_db_form() {
  global $db_host;
  global $db_port;
  global $db_user;
  global $db_password;
  global $db_name;
  global $image_repository_path;
  global $site_url;
  global $site_title;

  print "<h4>Configured Settings:  If any of these are incorrect, edit include/site_config.php</h4>\n";
  print "<form method=\"post\" action=\"install.php\">\n";
  print "<table>\n";
  print "<tr><td>DB Host</td><td>$db_host</td></tr>\n";
  print "<tr><td>DB Port</td><td>$db_port</td></tr>\n";
  print "<tr><td>DB Username</td><td>$db_user</td></tr>\n";
  print "<tr><td>DB Password</td><td>********</td></tr>\n";
  print "<tr><td>DB Name</td><td>$db_name</td></tr>\n";
  print "<tr><td>Site URL</td><td>$site_url</td></tr>\n";
  print "<tr><td>Site Title</td><td>$site_title</td></tr>\n";
  print "<tr><td>Image Repository</td><td>$image_repository_path</td></tr>\n";
  print "</table>\n";
  print "<input type=\"hidden\" name=\"go\" value=\"1\" />\n";
  print "<input type=\"submit\" value=\"Install/Upgrade\" />\n";
  print "</form>\n";
}

  /* =============================================================== */

$db_host       = "127.0.0.1";
$db_port       = "5432";
$db_name       = "po_db";
$db_user       = "po_user";
$db_password   = "none";
$image_repository_path = "/export/po_dev_image_repository";
$site_url = "http://localhost/po";
$site_title = "My Photo Organizer";

  /* =============================================================== */

umask(0);

$go = $_REQUEST['go'];

$first_volume = "v0000";
$new_install = FALSE;

include "themes/aqua/theme.php";

print "<html><head><title>Photo Organizer Installer</title>";
print "<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"themes/aqua/screen.css\">\n";
print "</head><body>";
print "<h3>Photo Organizer Installation/Update Utility</h3>";

/* Sanity Checks */

if (!is_readable("include/config_site.php")) {
  print "<h4>Please create include/config_site.php with your site settings! (see installation instructions)</h4>\n";
  $go = 0;
 }

include "include/config.php"; /* Use configured defaults, if possible */

if (!$image_repository_path || !is_writable($image_repository_path)) {
  print "<h4>Image Repository Path '$image_repository_path' not present or not writable by webserver. Please correct.</h4>\n";
  $go = 0;
 }

  /* =============================================================== */

/* magic quotes and such.. */

if (get_magic_quotes_gpc()) {
  print "<h4>PHP's <i>magic_quotes_gpc</i> is enabled.  Unless you need it for aonther application, we recommend you disable this in <i>php.ini</i>.  Photo Organizer should work with it enabled, but it has not been tested.</h4>\n";
}

if (get_magic_quotes_runtime()) {
  print "<h4>PHP's <i>magic_quotes_runtime</i> is enabled.  Unless you need it for aonther application, we recommend you disable this in <i>php.ini</i>.  Photo Organizer should work with it enabled, but it has not been tested.</h4>\n";
}

if( ini_get('safe_mode') ) {
  print "<h4>PHP's <i>safe mode</i> is enabled.  Photo Organzier will not currently work with safe mode enabled.  Please disable it in <i>php.ini</i> before continuing.</h4>\n";
  $go = 0;
}

if( ! ini_get('file_uploads') ) {
  print "<h4>PHP's <i>file_uploads</i> feature is disabled.  As you cannot upload images with this enabled, you'll probably want to enable it in <i>php.ini</i>.</h4>\n";
}

$filesize = ini_get("upload_max_filesize");
$postsize = ini_get("post_max_size");
if ($filesize > $postsize)   $filesize = $postsize;

print "<h4>Current max upload file size is $filesize.  You may need to increase this.</h4>\n";

/* Now test for installed extensions */

if (!extension_loaded("pgsql")) {
  print "<h4>PHP's PostgreSQL extension not installed or enabled. Please correct.</h4>\n";
  $go = 0;
 }
if (!function_exists("bccomp")) {
  print "<h4>PHP's BC Math routines not installed or enabled. Please correct.</h4>\n";
  $go = 0;
 }

/* Test external utilities */

if (!is_executable($sys_convert)) {
  print "<h4>ImageMagick <i>convert</i> utility not installed at $sys_convert. Please correct.</h4>\n";
  $go = 0;
 }
if (!is_executable($sys_composite)) {
  print "<h4>ImageMagick <i>composite</i> utility not installed at $sys_composite. Please correct.</h4>\n";
  $go = 0;
 }
if (!is_executable($sys_exiftool)) {
  print "<h4><i>ExifTool</i> utility not installed at $sys_exiftool. Please correct if you wish to use it for EXIF Processing.</h4>\n";
 }
if (!is_executable($sys_dcraw)) {
  print "<h4><i>dcraw</i> utility not installed at $sys_dcraw. Please correct if you wish to work with RAW images.</h4>\n";
 }
if (!is_executable($sys_ps2pdf)) {
  print "<h4><i>ps2pdf</i> utility not installed at $sys_ps2pdf. Please correct if you wish to export to PDF.</h4>\n";
 }
if (!is_executable($sys_tar)) {
  print "<h4><i>tar</i> utility not installed at $sys_tar. Please correct if you wish to import or export .tar files.</h4>\n";
 }
if (!is_executable($sys_unzip)) {
  print "<h4><i>unzip</i> utility not installed at $sys_unzip. Please correct if you wish to import .zip files.</h4>\n";
 }

  /* =============================================================== */

/* Kick things off */

if (!$go) {
  display_db_form();
  print "</html>";
  exit(0);
 }

$db_connection = "host=" . $db_host . " port=" . $db_port . " dbname=" . $db_name . " user=" . $db_user . "  password=" . $db_password;
$dbh = pg_connect($db_connection); 

if ($dbh === FALSE) {
  print "<h3>Database connection failed; Are credentials valid?</h3>";
  display_db_form();
  print "</html>";
  exit(0);
 }

# Installation steps:

# su - postgres -c "psql template1 -c \"CREATE USER po_user WITH PASSWORD 'po_password' NOCREATEDB NOCREATEUSER;\""
# su - postgres -c "createdb -O po_user po_db --encoding utf8"
# cp -vr src/* /var/www/html/po/
# cp config_site.inc /var/www/html/po/include/config_site.php, modify it.
# mkdir /tmp/image_repo; chown apache:apache /tmp/image_repo
# tell user to kick off http://site/path/install.php
# su - postgres -c "createlang plpgsql po_db"

#$version = "(none)";
$version = po_get_version($dbh);
print "<h3> Current Photo Organizer DB version: $version</h3>\n";
$res = TRUE;

while ($res) {
  $version = po_get_version($dbh);
  $row = $versions[$version];
  if (!$row) {
    break;
  }
  print "<h4> Upgrading from Photo Organizer version $version</h4>\n";
  print "<ul>\n";
  if ($row["pre"]) {
    $res = $row["pre"]($dbh);
  }
  if ($res === FALSE) break;

  print "<li>Upgrading database structure...";
  pg_query($dbh, "begin");
  $res = po_process_db_file($dbh, "sql/$row[db_file]");
  if ($res === TRUE) {
    print "<font color=\"green\">OK</font></li>\n";
    print "<li>Upgrading database data...";
    $res = po_process_db_file($dbh, "sql/$row[dat_file]");
    if ($res === TRUE) {
      print "<font color=\"green\">OK</font></li>\n";
    } else {
      print "<font color=\"red\">FAILED</font></li>\n";
      print "<li><pre>" . pg_last_error($dbh) . "</pre></li>\n";
    }
  } else {
    print "<font color=\"red\">FAILED</font></li>\n";
    print "<li><pre>" . pg_last_error($dbh) . "</pre></li>\n";
  }
  
  if ($res === FALSE) {
    pg_query($dbh, "abort");
    break;
  }
  
  $res = pg_query($dbh, "commit");

  if ($res === FALSE) break;

  if ($row["post"]) {
    $res = $row["post"]($dbh);
    if ($res === FALSE) break;
  }

  print "</ul>\n";
}
if ($res === TRUE) {
  print "<h3> Install/Upgrade to version $version complete.</h3>\n";
  print "<h3> IMPORTANT:  remove install.php!</h3>\n";
 } else {
  print "</ul>\n";
  print "<h3> Correct the above errors, and try again.  We will pick up where we left off.</h3>\n";
 }

print "</body></html>";
exit(0);

  /* =============================================================== */

?>
