<?php

//  Copyright (C) 2002-2006 Balint Kis (balint-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

include_once "include/common.php";
include_once "include/site.php";
include_once "include/site.php";

$database = site_prolog();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier, type from users where session_id='$session_id'"));
if ($my_user_id[1] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$photo_id    = $_REQUEST['photo'];
$photo_data  = pg_fetch_row(pg_query($database, "
  select location, caption, date_of_exposure, medium_image_path, large_image_path,
         access_rights, users, hide_original,
         title, author, keyword, headline, caption_writer, caption,
         category, supplemental_category, credit, copyright_statement, web_statement,
         instructions, source, transmission_reference
    from photo, photo_version
   where photo.identifier = photo_version.photo
     and photo_version.master = 't'
     and photo.identifier = '$photo_id'"));
$folder_data = pg_fetch_row(pg_query($database, "
  select folder.identifier, folder.caption
    from photo, folder
   where photo.folder = folder.identifier
     and photo.identifier = '$photo_id'"));

/* this will enable administrators to edit photos */
if ($my_user_id[1] == $user_type['administrator']) {
  $user_id = $photo_data[6];
}
if (!$user_id) {
  $user_id = $my_user_id[0];
}

$user_name = pg_fetch_row(pg_query($database, "select identifier, last_name, first_name from users where identifier=$user_id"));

site_header($page_width, "Edit Photo Duplicate");
if ($my_user_id[0] == $user_id) {
  site_navigator(5, $my_user_id[1]);
  $user_display_string = "My Folders and Albums";
}
else {
  site_navigator(1, $my_user_id[1]);
  $user_display_string = sprintf("%s, %s", $user_name[1], $user_name[2]);
}
$path_to_folder = get_path_to_folder($database, $folder_data[0]);
$title = get_photo_title($photo_data[10], $photo_data[1]);
site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$user_name[0]\">$user_display_string</a>$path_to_folder : <a href=\"folder.php?folder=$folder_data[0]\">$folder_data[1]</a> : <a href=\"photo.php?photo=$photo_id\">$title</a> : Edit photo", "");

print "&nbsp;<br/>\n";
print "<center>\n";
display_shaded_photo("image.display.php?image=$photo_id&size=2&ver=$version", "", $image_repository_path . "/" . $photo_data[3]);
print "</center>\n";
print "&nbsp;<br/>\n";

$photo_tech = pg_fetch_row(pg_query($database, "select camera, lens, film, flash, scanner, filter, scan_resolution, aperture,
                                                       focal_length, shutter, camera_metering, camera_program, flash_mode,
                                                       exposure_comp, flash_comp, ev_difference, iso_override, support, scan_bitdepth, scan_multiscan
                                                  from photo_tech where photo=$photo_id"));

$users_location = pg_query($database, "select identifier, country, state, city, place from view_location order by country, state, city, place");
$users_camera   = pg_query($database, "select identifier, name, model, variation from view_camera where users=$user_id");
$users_lens     = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length from view_lens where users=$user_id");
$users_film     = pg_query($database, "select identifier, name, model, iso from view_film where users=$user_id");
$users_flash    = pg_query($database, "select identifier, name, model, variation from view_flash where users=$user_id");
$users_scanner  = pg_query($database, "select identifier, name, model, variation from view_scanner where users=$user_id");
$users_filter   = pg_query($database, "select identifier, name, model, variation from view_filter where users=$user_id");
$users_support  = pg_query($database, "select identifier, name, model, variation from view_support where users=$user_id");

$aperture        = pg_query($database, "select identifier, value from aperture");
$focal_length    = pg_query($database, "select identifier, value from focal_length order by value");
$shutter         = pg_query($database, "select identifier, value from shutter");
$ev_comp         = pg_query($database, "select identifier, value from ev_comp");
$camera_metering = pg_query($database, "select identifier, value from camera_metering");
$camera_program  = pg_query($database, "select identifier, value from camera_program");
$flash_mode      = pg_query($database, "select identifier, value from flash_mode");
$scan_resolution = pg_query($database, "select identifier, value from scan_resolution");
$scan_bitdepth   = pg_query($database, "select identifier, value from scan_bitdepth");
$scan_multiscan  = pg_query($database, "select identifier, value from scan_multiscan");
$iso_override    = pg_query($database, "select identifier, value from film_iso");

print "<center>\n";

print "<form method=\"post\" action=\"photo.edit.2.php\" enctype=\"multipart/form-data\">\n";
print "<input type=\"hidden\" name=\"photo\" value=\"$photo_id\">\n";
print "<input type=\"hidden\" name=\"full_date_of_exposure\" value=\"$photo_data[2]\">\n";
print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Title</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"title\" rows=\"2\">$photo_data[8]</textarea></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Author</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"author\" rows=\"2\">$photo_data[9]</textarea></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Keywords</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"keyword\" rows=\"3\">$photo_data[10]</textarea></td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Headline</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"headline\" rows=\"2\">$photo_data[11]</textarea></td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Caption Writer</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"caption_writer\" rows=\"2\">$photo_data[12]</textarea></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Caption</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"caption\" rows=\"7\">$photo_data[13]</textarea></td></tr>\n";
print "</td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Category</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<input type=\"text\" name=\"category\" size=\"3\" title=\"Category\" value=\"$photo_data[14]\"></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Supplemental Category</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"supplemental_category\" rows=\"7\">$photo_data[15]</textarea></td></tr>\n";
print "</td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Credit</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"credit\" rows=\"2\">$photo_data[16]</textarea></td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\" nowrap=\"nowrap\">Copyright Statement</td> <td align=\"left\" bgcolor=\"$color[table_body]\" width=\"70%\">";
print "<textarea wrap=\"hard\" name=\"copyright\" rows=\"7\">$photo_data[17]</textarea>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Web Statement</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"web_statement\" rows=\"2\">$photo_data[18]</textarea></td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Instructions</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"instructions\" rows=\"2\">$photo_data[19]</textarea></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Source</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"source\" rows=\"2\">$photo_data[20]</textarea></td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Transmission Refernce</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
print "<textarea wrap=\"soft\" name=\"transmission_reference\" rows=\"2\">$photo_data[21]</textarea></td></tr>\n";
print "</td></tr>\n";

print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Exposure date</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
$date_of_exposure=$photo_data[2];
display_date_input_form("exposure_timestamp", "$date_of_exposure");
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Location</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_combo("location", $users_location, $photo_data[0], ", ", 1);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Access</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_access_combo("access_rights", $photo_data[5], "");
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">High Resolution Original</td><td align=\"left\" valign=\"middle\" bgcolor=\"$color[table_body]\" >";
display_hide_original_combo("hide_original", $photo_data[7]);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Camera</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_combo("camera", $users_camera, $photo_tech[0], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Camera Metering</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("camera_metering", $camera_metering, $photo_tech[10], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Camera Program</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("camera_program", $camera_program, $photo_tech[11], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Lens</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_lens_combo("lens", $users_lens, $photo_tech[1], 0, 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Focal Length</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("focal_length", $focal_length, $photo_tech[8], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Filter</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("filter", $users_filter, $photo_tech[5], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Film</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("film", $users_film, $photo_tech[2], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Film ISO Override</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("iso_override", $iso_override, $photo_tech[16], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Aperture</td><td align=\"left\" bgcolor=\"$color[table_body]\" >";
display_combo("aperture", $aperture, $photo_tech[7], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Shutter Speed</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("shutter", $shutter, $photo_tech[9], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Exposure Compensation</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("exp_comp", $ev_comp, $photo_tech[13], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Ev Difference</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("exp_diff", $ev_comp, $photo_tech[15], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Flash</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("flash", $users_flash, $photo_tech[3], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Flash Mode</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("flash_mode", $flash_mode, $photo_tech[12], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Flash Compensation</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("flash_comp", $ev_comp, $photo_tech[14], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Scanner</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("scanner", $users_scanner, $photo_tech[4], "", 0);
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Scan Parameters</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("scan_resolution", $scan_resolution, $photo_tech[6], "", 0);
print "dpi &nbsp;\n";
display_combo("scan_bitdepth", $scan_bitdepth, $photo_tech[18], "", 0);
print "bits &nbsp;\n";
display_combo("scan_multiscan", $scan_multiscan, $photo_tech[19], "", 0);
print "passes &nbsp;\n";
print "</td></tr>\n";
print "<tr><td align=\"right\" bgcolor=\"$color[table_header]\" width=\"25%\">Support</td><td align=\"left\" bgcolor=\"$color[table_body]\" >\n";
display_combo("support", $users_support, $photo_tech[17], "", 0);
print "</td></tr>\n";
print "</table>\n";
print "&nbsp;<br/>\n";
print "<input type=\"image\" src=\"$theme/button.save.changes.gif\" border=\"0\" value=\"Save Changes\">\n";
print "<a class=\"nodecor\" class=\"nodecor\" href=\"photo.php?photo=$photo_id\"><img src=\"$theme/button.cancel.gif\" border=\"0\" alt=\"Cancel\"></a>\n";
print "</form>\n";
print "</center>\n";

print "&nbsp;<br/>\n";

site_footer($database);
site_epilog($database);
?>
