
--  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.12 to v2.13 patch
----------------------------------------------------------

alter table photo_version add column original_image_name varchar(500);

alter table preferences add quota_size integer;
alter table preferences add quota_count integer;

alter table system_preferences add new_user_quota_size integer;
alter table system_preferences add new_user_quota_count integer;

create function count_photo_versions() returns bigint
as 'select count(identifier) from photo_version' language 'sql';

create function count_photo_versions_by_user(integer) returns bigint
as 'select count(photo_version.identifier) from photo_version, photo where photo_version.photo=photo.identifier and photo.users = $1' language 'sql';
