<?php

//  Copyright (C) 2002-2006 Balint Kis (balint-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/admin.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

include_once "include/common.php";
include_once "include/site.php";
include_once "include/import.php";
include_once "include/site.php";

$database = site_prolog();
$my_user_id = pg_fetch_row(pg_query($database, "
    select identifier, type
      from users
     where session_id='$session_id'"));

if ($my_user_id[1] < $user_type['administrator']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$selector = $_REQUEST['selector'];
if (!$selector) {
  $selector = 1;
}

$all_user_types = pg_query($database, "
    select user_type.identifier, user_type.value from user_type
     where identifier != $user_type[administrator]");

$system_preferences = pg_fetch_row(pg_query($database, "
    select user_type.value, new_user_bulk_upload_enable, paper.name, new_user_label, current_volume, volume_max_size, new_user_shop_enable,
           new_user_quota_size, new_user_quota_count, new_user_shared
      from system_preferences, user_type, paper, label
     where system_preferences.new_user_type=user_type.identifier
       and system_preferences.new_user_paper = paper.identifier"));

error_reporting(0);

$version = pg_fetch_assoc(pg_query($database, "select major,minor,variation from version"));

site_header($page_width, "Administrator Interface"); 
site_navigator(9, $my_user_id[1], $user_type);
site_navigator_status("Administrator Interface", "PHP v" . version() . " DB v$version[major].$version[minor].$version[variation]");


print "&nbsp;<br/>";
display_navigator_box_top($selector, $admin_data, "100%");

print "&nbsp;<br/>";
switch ($selector) {
 case $admin_data['repository']['idx']:
   display_image_repository($image_repository_path, $system_preferences);
   break;
 case $admin_data['new_user']['idx']:
   display_new_user_properties($database, $system_preferences);
   break;
 case $admin_data['users_n_clients']['idx']:
   display_users_and_clients($database, $my_user_id[0]);
   break;
 case $admin_data['front_page']['idx']:
   display_front_page_editor("index.php");
}
display_navigator_box_bottom("100%");
print "&nbsp;<br/>";

site_footer($database);
site_epilog($database);
?>
