<?php

//  Copyright (C) 2002-2006 Balint Kis (balint-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/tools.php";
include_once "include/mime.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

$operator        = $_REQUEST['operator'];
$select_folder   = $_REQUEST['select_folder'];
$select_album    = $_REQUEST['select_album'];
$spool_album     = $_REQUEST['spool_album'];
$selection       = $_REQUEST['selection'];
$to_update       = $_REQUEST['to_update'];

if (!$selection) {
  /* return if no search criteria exists */
  header("location: my.tools.php?selector=1");
 }

if (!$to_update) {
  /* return if no update criteria exists */
  header("location: my.tools.php?selector=1");
 }

include_once "include/common.php";
include_once "include/site.php";
include_once "include/import.php";

$database = site_prolog();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier, type from users where session_id='$session_id'"));
if ($my_user_id[1] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$set_generate_images        = $_REQUEST['set_generate_images'];

site_header($page_width, "Display Tools");
site_navigator(10, $my_user_id[1]);
site_navigator_status("<a href=\"user.php\">Users</a> : My Tools", "");

print "&nbsp;<br/>";
display_navigator_box_top($tools_data['bulkupdate']['idx'], $tools_data, "100%");

$update_photo_sql = "";
$update_photo_tech_sql = "";

foreach ($to_update as $field) {
  switch ($field) {
  case 'set_title':
    $set_title                  = pg_escape_string($_REQUEST['set_title']);
    $update_photo_sql .= " title = '$set_title', ";
    break;
  case 'set_author':
    $set_author                 = pg_escape_string($_REQUEST['set_author']);
    $update_photo_sql .= " author = '$set_author', ";
    break;
  case 'set_keyword':
    $set_keyword                = pg_escape_string($_REQUEST['set_keyword']);
    $update_photo_sql .= " keyword = '$set_keyword', ";
    break;
  case 'set_headline':
    $set_headline               = pg_escape_string($_REQUEST['set_headline']);
    $update_photo_sql .= " headline = '$set_headline', ";
    break;
  case 'set_caption_writer':
    $set_caption_writer         = pg_escape_string($_REQUEST['set_caption_writer']);
    $update_photo_sql .= " caption_writer = '$set_caption_writer', ";
    break;
  case 'set_caption':
    $set_caption                = pg_escape_string($_REQUEST['set_caption']);
    $update_photo_sql .= " caption = '$set_caption', ";
    break;
  case 'set_category':
    $set_category               = pg_escape_string($_REQUEST['set_category']);
    $update_photo_sql .= " category = '$set_category', ";
    break;
  case 'set_supplemental_category':
    $set_supplemental_category  = pg_escape_string($_REQUEST['set_supplemental_category']);
    $update_photo_sql .= " supplemental_category = '$set_supplemental_category', ";
    break;
  case 'set_credit':
    $set_credit                 = pg_escape_string($_REQUEST['set_credit']);
    $update_photo_sql .= " credit = '$set_credit', ";
    break;
  case 'set_copyright':
    $set_copyright              = pg_escape_string($_REQUEST['set_copyright']);
    $update_photo_sql .= " copyright = '$set_copyright', ";
    break;
  case 'set_web_statement':
    $set_web_statement          = pg_escape_string($_REQUEST['set_web_statement']);
    $update_photo_sql .= " web_statement = '$set_web_statement', ";
    break;
  case 'set_instructions':
    $set_instructions           = pg_escape_string($_REQUEST['set_instructions']);
    $update_photo_sql .= " instructions = '$set_instructions', ";
    break;
  case 'set_source':
    $set_source                 = pg_escape_string($_REQUEST['set_source']);
    $update_photo_sql .= " source = '$set_source', ";
    break;
  case 'set_transmission_reference':
    $set_transmission_reference = pg_escape_string($_REQUEST['set_transmission_reference']);
    $update_photo_sql .= " transmission_reference = '$set_transmission_reference', ";
    break;
  case 'set_date_of_exposure':
    $set_date_of_exposure = check_date_validity($_REQUEST['set_date_of_exposure']);
    $update_photo_sql .= " date_of_exposure= $set_date_of_exposure, ";
    break;
  case 'set_location':
    $set_location                 = $_REQUEST['set_location'];
    $update_photo_sql .= " location = $set_location, ";
    break;
  case 'set_access_rights':
    $set_access_rights                 = $_REQUEST['set_access_rights'];
    $update_photo_sql .= " access_rights = $set_access_rights, ";
    break;
  case 'set_hide_original':
    $set_hide_original                 = $_REQUEST['set_hide_original'];
    $update_photo_sql .= " hide_original = $set_hide_original, ";
    break;
  case 'set_camera':
    $set_camera                 = $_REQUEST['set_camera'];
    $update_photo_tech_sql .= " camera = $set_camera, ";
    break;
  case 'set_camera_metering':
    $set_camera_metering        = $_REQUEST['set_camera_metering'];
    $update_photo_tech_sql .= " camera_metering = $set_camera_metering, ";
    break;
  case 'set_camera_program':
    $set_camera_program                 = $_REQUEST['set_camera_program'];
    $update_photo_tech_sql .= " camera_program = $set_camera_program, ";
    break;
  case 'set_lens':
    $set_lens                 = $_REQUEST['set_lens'];
    $update_photo_tech_sql .= " lens = $set_lens, ";
    break;
  case 'set_focal_length':
    $set_focal_length                = $_REQUEST['set_focal_length'];
    $update_photo_tech_sql .= " focal_length = $set_focal_length, ";
    break;
  case 'set_filter':
    $set_filter                 = $_REQUEST['set_filter'];
    $update_photo_tech_sql .= " filter = $set_filter, ";
    break;
  case 'set_film':
    $set_film                 = $_REQUEST['set_film'];
    $update_photo_tech_sql .= " film = $set_film, ";
    break;
  case 'set_iso_override':
    $set_iso_override                = $_REQUEST['set_iso_override'];
    $update_photo_tech_sql .= " iso_override = $set_iso_override, ";
    break;
  case 'set_aperture':
    $set_aperture                 = $_REQUEST['set_aperture'];
    $update_photo_tech_sql .= " aperture = $set_aperture, ";
    break;
  case 'set_shutter':
    $set_shutter                 = $_REQUEST['set_shutter'];
    $update_photo_tech_sql .= " shutter = $set_shutter, ";
    break;
  case 'set_exp_comp':
    $set_exp_comp                 = $_REQUEST['set_exp_comp'];
    $update_photo_tech_sql .= " exposure_comp = $set_exp_comp, ";
    break;
  case 'set_exp_diff':
    $set_exp_diff                 = $_REQUEST['set_exp_diff'];
    $update_photo_tech_sql .= " ev_difference = $set_exp_diff, ";
    break;
  case 'set_flash':
    $set_flash                 = $_REQUEST['set_flash'];
    $update_photo_tech_sql .= " flash = $set_flash, ";
    break;
  case 'set_flash_mode':
    $set_flash_mode                 = $_REQUEST['set_flash_mode'];
    $update_photo_tech_sql .= " flash_mode = $set_flash_mode, ";
    break;
  case 'set_flash_comp':
    $set_flash_comp                 = $_REQUEST['set_flash_comp'];
    $update_photo_tech_sql .= " flash_comp = $set_flash_comp, ";
    break;
  case 'set_scanner':
    $set_scanner                = $_REQUEST['set_scanner'];
    $update_photo_tech_sql .= " scanner = $set_scanner, ";
    break;
  case 'set_scan_params':
    $param               = $_REQUEST['set_scan_resolution'];
    $update_photo_tech_sql .= " scan_resolution = $param, ";
    $param               = $_REQUEST['set_scan_bitdepth'];
    $update_photo_tech_sql .= " scan_bitdepth = $param, ";
    $param               = $_REQUEST['set_scan_multiscan'];
    $update_photo_tech_sql .= " scan_multiscan = $param, ";
    break;
  case 'set_support':
    $set_support                = $_REQUEST['set_support'];
    $update_photo_tech_sql .= " support = $set_support, ";
    break;
  default:
    # XXXX we should never get here!
    break;
  }
}

switch ($selection) {
 case 'folder':
  if ($select_folder == "all")
    $sql_selector = " users = $my_user_id[0] ";
  else
    $sql_selector = " folder = $select_folder ";
  break;
 case 'album':
  $sql_selector = " identifier in( select photo from album_content where album = $select_album) ";
  break;
 case 'spool':
   $sql_selector = " identifier in( select photo from album_content where album = $spool_album)";
  break;
 default:
   header("location: my.tools.php?selector=1");
   exit();
   break;
}

$num_of_updates = pg_fetch_row(pg_query($database, "
  select count(identifier) from photo
   where $sql_selector"));

if ($update_photo_sql != "") {
  $update_photo_sql = substr($update_photo_sql, 0, strlen($update_photo_sql) - 2);

       print "<li>$update_photo_sql</li>";
       print "<li>$sql_selector</li>";

  $result = pg_query($database, "
  update photo set
     $update_photo_sql
   where $sql_selector");
}

if ($update_photo_tech_sql != "") {
  $update_photo_tech_sql = substr($update_photo_tech_sql, 0, strlen($update_photo_tech_sql) - 2);

    print "<li>$update_photo_tech_sql</li>"; 
    print "<li>$sql_selector</li>";

  $result = pg_query($database, "
  update photo_tech set
     $update_photo_tech_sql
   where photo in (select identifier from photo where $sql_selector)");
}

print "<p align=\"left\">Updated $num_of_updates[0] photos.</p>";

if (($set_generate_images == 't')) {
  $im_options = get_im_options($database, $my_user_id[0]);
  $my_im_composite_options = get_im_composite_options($database, $my_user_id[0]);
  $dcraw_options = get_dcraw_options($database, $my_user_id[0]);

  print "<div align=\"left\">";

  $limit = 20;
  $offset = 0;
  while (1) {
    $photo = pg_query($database, "
      select small_image_path, medium_image_path, large_image_path, title, photo.identifier, colorspace, orientation, photo.identifier
        from photo, photo_version
       where photo.identifier = photo_version.photo
         and $sql_selector
       limit $limit
      offset $offset");

    $num_of_photos = pg_num_rows($photo);

    if ($num_of_photos == 0)
      break;

    for ($counter = 0; $counter < $num_of_photos; $counter++) {
      $photo_data = pg_fetch_row($photo, $counter);

      $camera_profile = pg_fetch_row(pg_query($database, "
    select raw_icc_profile 
      from photo_tech, camera, camera_type
     where photo_tech.photo = $photo_data[7]
       and photo_tech.camera = camera.identifier
       and camera.type = camera_type.identifier"));

      $thumb_name    = $image_repository_path ."/". $photo_data[0];
      $image_name    = $image_repository_path ."/". $photo_data[1];
      $original_name = $image_repository_path ."/". $photo_data[2];
      $orientation = orientation_to_xform($database, $photo_data[6]);

      $original_file_type   = strtolower(substr($original_name, strrpos($original_name, ".") + 1));
      $multi_page_parameter = $mime_type[$original_file_type]['page'];
      $decoder              = $mime_type[$original_file_type]['decoder'];

      print "Regenerating thumbnail and preview for <a href=\"photo.php?photo=$photo_data[4]\">$photo_data[3]</a>.<ul>";

      $temporary_ppm_file = import_raw_decode($original, $dcraw_options, $decoder, $camera_profile[0], TRUE);
      if ($temporary_ppm_file) {
	$original = $temporary_ppm_file;
      } 

      import_generate_preview($original_name, $image_name, TRUE, $im_options, $my_im_composite_options, $multi_page_parameter, $orientation, $photo_data[5]);
      import_generate_thumbnail($original_name, $thumb_name, TRUE, $im_options, $multi_page_parameter, $orientation, $photo_data[5]);

      if ($temporary_ppm_file) {
	unlink($temporary_ppm_file);
      }

      print "</ul>";
    }

    $offset += $limit;
  }
  print "</div>";
}

print "<p>";
print "<a class=\"nodecor\" href=\"my.tools.php?selector=1\"><img src=\"$theme/button.back.gif\" border=\"0\"></a>";
print "</p>";


display_navigator_box_bottom("100%");
print "&nbsp;<br/>";

site_footer($database);
site_epilog($database);

?>
