<?php

//  Copyright (C) 2002-2006 Balint Kis (balint-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

$profile_data = array("lens"         => array("idx" => 1, "active_img" => "$theme/navigator.eq.lens.a.gif",         "img" => "$theme/navigator.eq.lens.gif",         link => "my.profile.php?selector=1",  "alt" => " Lenses "),
                      "camera"       => array("idx" => 2, "active_img" => "$theme/navigator.eq.camera.a.gif",       "img" => "$theme/navigator.eq.camera.gif",       link => "my.profile.php?selector=2",  "alt" => " Cameras "),
                      "flash"        => array("idx" => 3, "active_img" => "$theme/navigator.eq.flash.a.gif",        "img" => "$theme/navigator.eq.flash.gif",        link => "my.profile.php?selector=3",  "alt" => " Flashes "),
                      "scanner"      => array("idx" => 4, "active_img" => "$theme/navigator.eq.scanner.a.gif",      "img" => "$theme/navigator.eq.scanner.gif",      link => "my.profile.php?selector=4",  "alt" => " Scanners "),
                      "filter"       => array("idx" => 5, "active_img" => "$theme/navigator.eq.filter.a.gif",       "img" => "$theme/navigator.eq.filter.gif",       link => "my.profile.php?selector=5",  "alt" => " Filters "),
                      "film"         => array("idx" => 6, "active_img" => "$theme/navigator.eq.film.a.gif",         "img" => "$theme/navigator.eq.film.gif",         link => "my.profile.php?selector=6",  "alt" => " Films "),
                      "support"      => array("idx" => 7, "active_img" => "$theme/navigator.eq.support.a.gif",      "img" => "$theme/navigator.eq.support.gif",      link => "my.profile.php?selector=7",  "alt" => " Supports "),
                      "manufacturer" => array("idx" => 8, "active_img" => "$theme/navigator.eq.manufacturer.a.gif", "img" => "$theme/navigator.eq.manufacturer.gif", link => "my.profile.php?selector=8",  "alt" => " Manufacturers "),
                      "label"        => array("idx" => 9, "active_img" => "$theme/navigator.eq.label.a.gif",        "img" => "$theme/navigator.eq.label.gif",        link => "my.profile.php?selector=9",  "alt" => " Labels "),
                      "shop"         => array("idx" => 10,"active_img" => "$theme/navigator.eq.shop.a.gif",         "img" => "$theme/navigator.eq.shop.gif",         link => "my.profile.php?selector=10", "alt" => " Shop "),
                      "location"     => array("idx" => 11,"active_img" => "$theme/navigator.eq.location.a.gif",     "img" => "$theme/navigator.eq.location.gif",     link => "my.profile.php?selector=11", "alt" => " Locations "));

function display_lens($database, $my_user_id, $user_id) {
  global $color;
  global $style;
  global $access;

  if ($my_user_id==$user_id) {
    $all_lenses = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length, serial_number, date_of_purchase, purchased_new, url, access_rights
                                         from view_lens where users=$user_id order by name");
  }
  else {
    if ($user_id != "" && $my_user_id != "")
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$user_id' and client='$my_user_id' and status=2"));
    if ($client =="")
      $all_lenses = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length, serial_number, date_of_purchase, purchased_new, url, access_rights
                                           from view_lens where users=$user_id and access_rights=$access[public] order by name");
    else
      $all_lenses = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length, serial_number, date_of_purchase, purchased_new, url, access_rights
                                           from view_lens where users=$user_id and access_rights<=$access[protected] order by name");
  }

  $num_of_lenses = pg_num_rows($all_lenses);
  if ($my_user_id != $user_id && $num_of_lenses == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\">Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"35%\">Model</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"13%\">Serial Number</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"7%\">New</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\" nowrap>Purchase Date</td>\n";
  if ($my_user_id==$user_id) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Access</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"lens.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_lenses; $i++) {
    $lens = pg_fetch_row($all_lenses, $i);
    print "<tr>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$lens[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$lens[11]\">$lens[1]</a> $lens[2] $lens[3]\n";
    display_lens_string($lens[4], $lens[5], $lens[6], $lens[7]);
    print "</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$lens[8]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >"; display_yes_no_text($lens[10]); print"</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($lens[9], 'date', $my_user_id == "" ? 0 : 1). "</td>\n";
    if ($my_user_id==$user_id) {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$lens[12]</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"lens.edit.php?item=$lens[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"lens.del.php?item=$lens[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_camera($database, $my_user_id, $user_id) {
  global $color;
  global $style;
  global $access;
  global $icc_profiles;

  if ($my_user_id==$user_id) {
    $all_cameras = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights, raw_icc_profile
                                          from view_camera where users=$user_id order by name");
  }
  else {
    if ($user_id != "" && $my_user_id != "")
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$user_id' and client='$my_user_id' and status=2"));
    if ($client =="")
      $all_cameras = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights, raw_icc_profile
                                            from view_camera where users=$user_id and access_rights=$access[public] order by name");
    else
      $all_cameras = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights, raw_icc_profile
                                            from view_camera where users=$user_id and access_rights<=$access[protected] order by name");
  }

  $num_of_cameras = pg_num_rows($all_cameras);
  if ($my_user_id!=$user_id && $num_of_cameras == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\">Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"25%\">Model</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"13%\">Serial Number</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"7%\">New</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\" nowrap>Purchase Date</td>\n";
  if ($my_user_id==$user_id) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" >Access</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" >ICC Profile</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"camera.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_cameras; $i++) {
    $camera = pg_fetch_row($all_cameras, $i);
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$camera[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$camera[7]\">$camera[1]</a> $camera[2] $camera[3]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$camera[4]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >"; display_yes_no_text($camera[6]); print"</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($camera[5], 'date', $my_user_id == "" ? 0 : 1). "</td>\n";
    if ($my_user_id==$user_id) {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$camera[8]</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >";
      print $icc_profiles[$camera[9]]['name'];
      print "</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"camera.edit.php?item=$camera[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"camera.del.php?item=$camera[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_flash($database, $my_user_id, $user_id) {
  global $color;
  global $style;
  global $access;

  if ($my_user_id==$user_id) {
    $all_flashes = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                          from view_flash where users=$user_id order by name");
  }
  else {
    if ($user_id != "" && $my_user_id != "")
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$user_id' and client='$my_user_id' and status=2"));
    if ($client =="")
      $all_flashes = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                            from view_flash where users=$user_id and access_rights=$access[public] order by name");
    else
      $all_flashes = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                            from view_flash where users=$user_id and access_rights<=$access[protected] order by name");
  }

  $num_of_flashes = pg_num_rows($all_flashes);
  if ($my_user_id!=$user_id && $num_of_flashes == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\">Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"35%\">Model</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"13%\">Serial Number</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"7%\">New</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\" nowrap>Purchase Date</td>\n";
  if ($my_user_id==$user_id) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" >Access</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"flash.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_flashes; $i++) {
    $flash = pg_fetch_row($all_flashes, $i);
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$flash[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$flash[7]\">$flash[1]</a> $flash[2] $flash[3]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$flash[4]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >"; display_yes_no_text($flash[6]); print"</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($flash[5], 'date', $my_user_id == "" ? 0 : 1). "</td>\n";
    if ($my_user_id==$user_id) {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$flash[8]</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"flash.edit.php?item=$flash[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"flash.del.php?item=$flash[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_scanner($database, $my_user_id, $user_id) {
  global $color;
  global $style;
  global $access;

  global $access;
  if ($my_user_id==$user_id) {
    $all_scanners = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                           from view_scanner where users=$user_id order by name");
  }
  else {
    if ($user_id != "" && $my_user_id != "")
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$user_id' and client='$my_user_id' and status=2"));
    if ($client =="")
      $all_scanners = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                             from view_scanner where users=$user_id and access_rights=$access[public] order by name");
    else
      $all_scanners = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                             from view_scanner where users=$user_id and access_rights<=$access[protected] order by name");
  }

  $num_of_scanners = pg_num_rows($all_scanners);
  if ($my_user_id!=$user_id && $num_of_scanners == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\">Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"35%\">Model</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"13%\">Serial Number</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"7%\">New</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\" nowrap>Purchase Date</td>\n";
  if ($my_user_id==$user_id) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" >Access</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"scanner.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_scanners; $i++) {
    $scanner = pg_fetch_row($all_scanners, $i);
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$scanner[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$scanner[7]\">$scanner[1]</a> $scanner[2] $scanner[3]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$scanner[4]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >"; display_yes_no_text($scanner[6]); print"</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($scanner[5], 'date', $my_user_id == "" ? 0 : 1)."</td>\n";
    if ($my_user_id==$user_id) {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$scanner[8]</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"scanner.edit.php?item=$scanner[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"scanner.del.php?item=$scanner[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}


function display_support($database, $my_user_id, $user_id) {
  global $color;
  global $style;
  global $access;

  if ($my_user_id==$user_id) {
    $all_supports = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                          from view_support where users=$user_id order by name");
  }
  else {
    if ($user_id != "" && $my_user_id != "")
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$user_id' and client='$my_user_id' and status=2"));
    if ($client =="")
      $all_supports = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                             from view_support where users=$user_id and access_rights=$access[public] order by name");
    else
      $all_supports = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                             from view_support where users=$user_id and access_rights<=$access[protected] order by name");
  }

  $num_of_supports = pg_num_rows($all_supports);
  if ($my_user_id!=$user_id && $num_of_supports == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\">Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"35%\">Model</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"13%\">Serial Number</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"7%\">New</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\" nowrap>Purchase Date</td>\n";
  if ($my_user_id==$user_id) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" >Access</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"support.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_supports; $i++) {
    $support = pg_fetch_row($all_supports, $i);
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$support[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$support[7]\">$support[1]</a> $support[2] $support[3]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$support[4]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >"; display_yes_no_text($support[6]); print"</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($support[5], 'date', $my_user_id == "" ? 0 : 1). "</td>\n";
    if ($my_user_id==$user_id) {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$support[8]</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"support.edit.php?item=$support[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"support.del.php?item=$support[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_filter($database, $my_user_id, $user_id) {
  global $color;
  global $style;
  global $access;

  if ($my_user_id==$user_id) {
    $all_filters = pg_query($database, "select identifier, name, model, variation, date_of_purchase, purchased_new, url, access_rights
                                          from view_filter where users=$user_id order by name");
  }
  else {
    if ($user_id != "" && $my_user_id != "")
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$user_id' and client='$my_user_id' and status=2"));
    if ($client =="")
      $all_filters = pg_query($database, "select identifier, name, model, variation, date_of_purchase, purchased_new, url, access_rights
                                            from view_filter where users=$user_id and access_rights=$access[public] order by name");
    else
      $all_filters = pg_query($database, "select identifier, name, model, variation, date_of_purchase, purchased_new, url, access_rights
                                            from view_filter where users=$user_id and access_rights<=$access[protected] order by name");
  }

  $num_of_filters = pg_num_rows($all_filters);
  if ($my_user_id!=$user_id && $num_of_filters == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\">Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"35%\">Model</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"13%\"></td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"7%\">New</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\" nowrap>Purchase Date</td>\n";
  if ($my_user_id==$user_id) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" >Access</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"filter.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_filters; $i++) {
    $filter = pg_fetch_row($all_filters, $i);
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$filter[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$filter[8]\">$filter[1]</a> $filter[2] $filter[3]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >"; display_yes_no_text($filter[5]); print"</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($filter[4], 'date', $my_user_id == "" ? 0 : 1)."</td>\n";
    if ($my_user_id==$user_id) {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$filter[7]</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"filter.edit.php?item=$filter[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"filter.del.php?item=$filter[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_film($database, $my_user_id, $user_id) {
  global $color;
  global $style;
  global $access;

  if ($my_user_id==$user_id) {
    $all_films = pg_query($database, "select identifier, name, model, iso, format, url, access_rights
                                        from view_film where users=$user_id order by name");
  }
  else {
    if ($user_id != "" && $my_user_id != "")
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$user_id' and client='$my_user_id' and status=2"));
    if ($client =="")
      $all_films = pg_query($database, "select identifier, name, model, iso, format, url, access_rights
                                          from view_film where users=$user_id and access_rights=$access[public] order by name");
    else
      $all_films = pg_query($database, "select identifier, name, model, iso, format, url, access_rights
                                          from view_film where users=$user_id and access_rights<=$access[protected] order by name");
  }

  $num_of_films = pg_num_rows($all_films);
  if ($my_user_id!=$user_id && $num_of_films == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\">Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"35%\">Model</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"13%\"></td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"7%\"></td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\">Format</td>\n";
  if ($my_user_id==$user_id) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" >Access</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"film.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_films; $i++) {
    $film = pg_fetch_row($all_films, $i);
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$film[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$film[5]\">$film[1]</a> $film[2] $film[3]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$film[4]</td>\n";
    if ($my_user_id==$user_id) {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$film[6]</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"film.edit.php?item=$film[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"film.del.php?item=$film[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}


function display_manufacturer($database, $my_user_id, $user_id) {
  global $color;
  global $style;
  global $access;

  if ($user_id == "*")
    $all_manufacturers = pg_query($database, "select identifier, name, url, last_modified_date from manufacturer order by name");
  else
    $all_manufacturers = pg_query($database, "select identifier, name, url, last_modified_date
                                                from manufacturer where last_modifying_users=$user_id order by name");

  $num_of_manufacturers = pg_num_rows($all_manufacturers);
  if ($user_id == "*" && $num_of_manufacturers == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  if ($user_id == "*") {
    print "<tr bgcolor=\"$color[table_top]\">\n";
    print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"4\"><font class=\"header\">All Manufacturers in the System</font></td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\">Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"25%\">Name</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"40%\">URL</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\" nowrap>Created</td>\n";
  if ($user_id != "*")
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"manufacturer.add.php\">Add</a></td>\n";
  print "</tr>\n";

  for ($i=0; $i < $num_of_manufacturers; $i++) {
    $manufacturer = pg_fetch_row($all_manufacturers, $i);
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$manufacturer[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$manufacturer[2]\">$manufacturer[1]</a></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$manufacturer[2]\">$manufacturer[2]</a></td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($manufacturer[3], 'date', $my_user_id == "" ? 0 : 1). "</td>\n";
    if ($user_id != "*") {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"manufacturer.edit.php?item=$manufacturer[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"manufacturer.del.php?item=$manufacturer[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_label($database, $my_user_id, $user_id) {
  global $color;
  global $style;

  if ($user_id == "*") {
    $all_labels = pg_query($database, "
      select label.identifier,
             (select url from manufacturer where identifier=label.manufacturer),
             (select name from manufacturer where identifier=label.manufacturer),
             label.name, paper.name,
             space_x, space_y, label.size_x, label.size_y, offset_x, offset_y,
             columns, rows, date_of_creation
        from label, paper
       where label.paper=paper.identifier
       order by label.identifier");
  }
  else {
    $all_labels = pg_query($database, "
      select label.identifier,
             (select url from manufacturer where identifier=label.manufacturer),
             (select name from manufacturer where identifier=label.manufacturer),
             label.name, paper.name,
             space_x, space_y, label.size_x, label.size_y, offset_x, offset_y,
             columns, rows, date_of_creation
        from label, paper
       where label.paper=paper.identifier
         and label.users=$my_user_id
       order by label.identifier");
  }

  $num_of_labels = pg_num_rows($all_labels);
  if ($user_id == "*" && $num_of_labels == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  if ($user_id == "*") {
    print "<tr bgcolor=\"$color[table_top]\">\n";
    print "<td align=\"left\" bgcolor=\"$color[table_top]\"colspan=\"11\"><font class=\"header\">All Labels in the System</font></td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\">Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"25%\">Model</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\" nowrap>H Space</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\" nowrap>V Space</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\" nowrap>Width</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\" nowrap>Height</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\" nowrap>H Offset</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\" nowrap>V Offset</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\" nowrap>Rows</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\" nowrap>Colums</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\" nowrap>Created</td>\n";
  if ($user_id != "*") {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"label.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_labels; $i++) {
    $label = pg_fetch_row($all_labels, $i);
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$label[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"$label[1]\">$label[2]</a> $label[3], $label[4]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$label[5]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$label[6]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$label[7]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$label[8]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$label[9]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$label[10]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$label[11]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$label[12]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($label[13], 'date', $my_user_id == "" ? 0 : 1). "</td>\n";
    if ($user_id != "*") {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"label.edit.php?item=$label[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"label.del.php?item=$label[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_location($database, $my_user_id) {
  global $color;
  global $style;

  if ($my_user_id == "*") {
    $result = pg_query($database, "select identifier, place, city, state, country, last_modified_date, latitude, longitude
                                     from view_location
                                    order by country, state, city, place");
  }
  else {
    $result = pg_query($database, "select identifier, place, city, state, country, last_modified_date, latitude, longitude
                                     from view_location
                                    where last_modifying_users=$my_user_id
                                    order by country, state, city, place");
  }

  $num = pg_num_rows($result);

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  if ($my_user_id == "*") {
    print "<tr bgcolor=\"$color[table_top]\">\n";
    print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"5\"><font class=\"nodecor\">All Locations in the System</font></td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\">Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"45%\">Description</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Latitude</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Longitude</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\" nowrap>Created</td>\n";
  if ($my_user_id != "*") {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"location.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num; $i++) {
    $r = pg_fetch_row($result, $i);
    if ($r[1] != '' && ($r[2] != '' || $r[3] != '' ||  $r[4] != '')) {
      $r[1] = sprintf("%s,", $r[1]);
    }
    if ($r[2] != '' && ($r[3] != '' ||  $r[4] != '')) {
      $r[2] = sprintf("%s,", $r[2]);
    }
    if ($r[3] != '' && $r[4] != '') {
      $r[3] = sprintf("%s,", $r[3]);
    }
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$r[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$r[1] $r[2] $r[3] $r[4]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$r[6]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$r[7]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($r[5], 'date', $my_user_id == "" ? 0 : 1)."</td>\n";
    if ($my_user_id != "*") {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"location.edit.php?item=$r[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"location.del.php?item=$r[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}


function display_shop_items($database, $my_user_id, $user_id) {
  global $color;
  global $style;

  if ($user_id == "*") {
    $all_shop_items = pg_query($database, "
      select shop_item.identifier, description, shop_item.date_of_creation, caption
        from shop_item, shop_category
       where shop_item.category = shop_category.identifier");
  }
  else {
    $all_shop_items = pg_query($database, "
      select shop_item.identifier, description, shop_item.date_of_creation, caption
        from shop_item, shop_category
       where shop_item.category = shop_category.identifier
         and shop_item.users=$my_user_id");
  }

  $num_of_shop_items = pg_num_rows($all_shop_items);
  if ($user_id == "*" && $num_of_shop_items == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr bgcolor=\"$color[table_top]\">\n";
  if ($user_id == "*") {
    print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"11\"><font class=\"header\">All Shop Items in the System</font></td>\n";
  }
  else {
    print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"11\"><font class=\"header\">Shop Items</font></td>\n";
  }
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\" nowrap>Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"50%\" nowrap>Description</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\" nowrap>Category</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"15%\" nowrap>Created</td>\n";
  if ($user_id != "*") {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"shop.item.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_shop_items; $i++) {
    $shop_item = pg_fetch_row($all_shop_items, $i);
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$shop_item[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$shop_item[1]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$shop_item[3]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($shop_item[2], 'date', $my_user_id == "" ? 0 : 1). "</td>\n";
    if ($user_id != "*") {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"shop.item.edit.php?item=$shop_item[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"shop.item.del.php?item=$shop_item[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_shop_categories($database, $my_user_id, $user_id) {
  global $color;
  global $style;

  if ($user_id == "*") {
    $all_shop_categories = pg_query($database, "
      select identifier, caption, date_of_creation
        from shop_category");
  }
  else {
    $all_shop_categories = pg_query($database, "
      select identifier, caption, date_of_creation
        from shop_category
       where users=$my_user_id");
  }

  $num_of_shop_categories = pg_num_rows($all_shop_categories);
  if ($user_id == "*" && $num_of_shop_categories == 0)
    return;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr bgcolor=\"$color[table_top]\">\n";
  if ($user_id == "*") {
    print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"11\"><font class=\"header\">All Shop Categories in the System</font></td>\n";
  }
  else {
    print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"11\"><font class=\"header\">Shop Categories</font></td>\n";
  }
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"5%\" nowrap>Id</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"70%\" nowrap>Description</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"15%\" nowrap>Created</td>\n";
  if ($user_id != "*") {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\" colspan=\"2\"><a href=\"shop.category.add.php\">Add</a></td>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_shop_categories; $i++) {
    $shop_category = pg_fetch_row($all_shop_categories, $i);
    print "<tr color=$color[table_body]>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$shop_category[0]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$shop_category[1]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($shop_category[2], 'date', $my_user_id == "" ? 0 : 1). "</td>\n";
    if ($user_id != "*") {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"shop.category.edit.php?item=$shop_category[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"shop.category.del.php?item=$shop_category[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

?>
